#!/usr/bin/perl
##############################################################################
# Cliff's Majordomo Tool Version 1.51                                        # 
# Copyright 1998 Shaven Ferret Productions                                   #
# Created 6/8/98                 Last Modified: 05/16/99                     #
# Available at http://www.shavenferret.com/scripts                           #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1998 Shaven Ferret Productions All Rights Reserved.              #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header or the part that makes the return link.  If you really  #
# need to change these things, go to                                         #
# http://www.shavenferret.com/scripts/register.shtml .  By using this script #
# you agree to indemnify me from any liability that might arise from its use.#
# In simple English, if this script somehow makes your computer run amuck    #
# and kill the pope, it's not my fault.                                      #                   #
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################

# Change the next variable to the location of sendmail
$mailprogram = "/usr/sbin/sendmail";

##############################################################################
# Congratulations!  You've finished defining the variables.  If you want to, #
# you can continue screwing with the script, but it isn't necessary.         #
##############################################################################

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $FORM{$name} = $value;
}
$mailthis = "To: $FORM{'majordomo'}\n";
print "Content-type: text/html\n\n";

# make sure the user entered a valid email address.

$temp = $FORM{'email'};
$temp =~ s/_/a/g;
$temp =~ s/-/a/g;
unless ($temp =~ /\w+@\w+\.\w\w+/) {
        print "<html><head><title>Please enter your email address</title></head>\n";
        print "<body bgcolor=white><br><center><font size=5 color=blue>\n";
        print "Please enter your full email address.\n";
        &print_form("email");
        print "</body></html>\n";
        exit;
}

$mailthis .= "From: $FORM{'email'}\n";
$mailthis .= "subject: majordomo commands\n";
$mailthis .= "$FORM{'action'}";
if ($FORM{'list'}) { $mailthis .= " $FORM{'list'}"; }
if ($FORM{'file'}) { $mailthis .= " $FORM{'file'}"; }

open(MAIL,"|$mailprogram -t");
print MAIL "$mailthis\n";        
close(MAIL);

print "<html><head><title>Thank you!</title></head><body>\n";
print "<FONT FACE=\"helvetica,arial\" SIZE=5><B><center>Commands sent</B><BR></FONT><FONT FACE=\"Arial,Helvetica\" SIZE=\"-1\">The commands have been sent\n";
print "to Majordomo.\n";
print "<center><hr width=\"500\">Return to <a href=\"http://www.yourdomain.com\">Your web site</a><hr width=\"500\"></center>\n";
print "</body></html>\n";
exit;

sub print_form {
        $dontprint = shift(@_);
        print "<form method=\"POST\">\n";
        foreach $pair (@pairs) {
                ($name, $value) = split(/=/, $pair);
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
                unless ($name eq $dontprint) { print "<input type=\"hidden\" name=\"$name\" value=\"$value\">\n"; }
                else { print "<input type=\"text\" name=\"$dontprint\">\n"; }
        }
        print "<input type=\"submit\"></form>\n";
}
